#!/bin/bash
#Synchronisierung webapp zum Zielserver
#Benutzer Variablen:
#REMOTE_HOST ->Ziel-Hostname
#REMOTE_USER ->Ziel-Benutzerkennung
#REMOTE_DIR -> Zielpfad

if [ "$LOCAL_DIR" = ""  ]
	then
		LOCAL_DIR=`pwd`
fi



if [ "$REMOTE_HOST" = ""  ]
	then
		rsync -L -rauvz  $LOCAL_DIR/WEB-INF/conf/edustore/db/* $REMOTE_DIR/db
	else
		rsync -L -rauvz -e ssh $LOCAL_DIR/WEB-INF/conf/edustore/db/* "$REMOTE_USER"@"$REMOTE_HOST":$REMOTE_DIR/db
fi

