# Ansible Script for Installing superx on Ubuntu 22.04

This repo provides an ansible playbook for a convenient way to install

This playbook needs ansible version >=2.10 to work, it also relies on a few dependencies from ansible community.

So if you are using ubuntu, make sure you install `ansible` instead of `ansible-core`.

(It was developed on a control node running Ubuntu 22.04)

For more information on ansible visit their [official documentation](https://docs.ansible.com/).

## Usage


To run the playbook simply enter the IP of your machine into the inventory file (see comments for examples).

Then run the following command:
```
ansible-playbook --ask-become main.yml
```

After the Playbook has finished, you need to manually create the database,
client, and user table in the admin interface.

## SSL

The default will install superx **without** SSL encryption.

For SSL encryption to work you **first** need to have the necessary files (e.g.
the certificates) in place before running the playbook.
Now you have to adjust the settings in the vars.yml file.


