# Ladeampel

**Beschreibung**  
Die Ladeampel kann in einem SuperX-Portlet eingebunden werden. Sie zeigt den Status der Laderoutinen der einzelnen Module. Dabei werden drei Zustände unterschieden:

- **Erfolg**: Die Laderoutine ist erfolgreich durchgelaufen
- **läuft gerade**: Die Laderoutine wird gerade ausgeführt
- **Fehler:**: Die Laderoutine ist mit einem Fehler beendet worden

## Installation

Die Ladeampel besteht aus vier Komponenten:

- **laderoutine.awk**: AWK-Programm, welches die Logfiles der Module einliest und den Status für jedes Modul ermittelt.
- **laderoutine.sh**: Bash-Skript, welches die Pfade zu den Logfiles der einzelnen Module enthält. Es ruft das AWL-Programm auf.
- **ladejobs.jsp**: Java Server Page, welche das Bash-Skript aufruft und für den Status eine Ampel und eine Tabelle mit dem Status aller Module ausgibt.
- **portlet.sql**: Enthält SQL-Insert-Statement zum Anlegen des Portlets in SuperX. Das Portlet enthält ein iFrame, welches die Java Server Page einbindet. Durch JavaScript wird das iFrame alle 60 Sekunden neu geladen, damit sich der Status aktuallisiert.

Die Installation erfolgt in folgenden Schritten:

1. Der Ordner *laderoutine* enthält das AWK-Programm und das Bash-Skript. Er kann z.B. im Home-Verzeichnis vom Linux-User *superx* abgelegt werden. 
2. Die JSP-Datei muss in den Ordner `/home/superx/webserver/tomcat/webapps/superx/`. 
3. In der JSP-Datei muss dann in Zeile 106 der Pfad zum Bash-Skript angepasst werden. 
4. Zuletzt muss die SQL-Datei ausgeführt werden, um das Portlet anzulegen. 
5. **Optional** Die Reihenfolge der Portlets wird über die tid der Tabelle `sx_portlet` bestimmt und lässt sich anpassen, um die Portlets umzusortieren, falls noch weitere Portlets vorhanden sind.

## Verwendung

Die Ampel sollte nun auf der Startseite von SuperX sichtbar sein. Alle 60 Sekunden wird die Ampel aktuallisiert, um den aktuellen Status anzuzeigen.

## Kontakt

- **Autor**: Alexander Bien (Universität zu Köln)
- **E-Mail**: a.bien@uni-koeln.de
